/****************************************
*                                       *
*       TP CSI2 - ESSI3 1998/99         *
*                                       *
*   CAUVIN Florian - NAVARRO Mikael     *
*                                       *
* Definition d'un structure de Maillage *
*                                       *
****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "maillage.h"

void CreateMaillage(Maillage *this,char* nom_fichier) {
  FILE *fichier;
  int j,k;

  /* lecture jm et km */
  fichier=fopen(nom_fichier,"r");
  fscanf(fichier,"# %d %d",&(this->jm),&(this->km));
  
  /* allocation de x et y */
  this->x=(double**) malloc(sizeof(double*) * (this->jm+1));
  this->y=(double**) malloc(sizeof(double*) * (this->jm+1));
  for (j=0;j<=this->jm;j++) {
    this->x[j]=(double*) malloc(sizeof(double) * (this->km+1));
    this->y[j]=(double*) malloc(sizeof(double) * (this->km+1));
  }

  /* remplissage de x et y grace au fichier */
  for(k=0;k<=this->km;k++) {
    fscanf(fichier,"\n");
    for(j=0;j<=this->jm;j++) {
      fscanf(fichier,"%lf %lf",&(this->x[j][k]),&(this->y[j][k]));
    }
  }

  this->nom=malloc(strlen(nom_fichier));
  strcpy(this->nom,nom_fichier);
  fclose(fichier);
}

void DestroyMaillage(Maillage *this) {
  int j;

  for(j=0;j<=this->jm;j++) {
    free(this->x[j]);
    free(this->y[j]);
    //free(this->psi[j]);
  }
  free(this->x);
  free(this->y);
  //free(this->psi);
}


void Save(Maillage *this,char* nom_fichier) {
  FILE *fichier;
  int j,k;

  fichier=fopen(nom_fichier,"w");
  fprintf(fichier,"# %d %d\n",this->jm,this->km);
  for(k=0;k<=this->km;k++) {
    fprintf(fichier,"\n");
    for(j=0;j<=this->jm;j++)
      fprintf(fichier,"%lf %lf\n",this->x[j][k],this->y[j][k]);
  }

  /* partie juste utile pour GNUPlot */
  for(j=0;j<=this->jm;j++) {
    fprintf(fichier,"\n");
    for(k=0;k<=this->km;k++)
      fprintf(fichier,"%lf %lf\n",this->x[j][k],this->y[j][k]);
  }

  realloc(this->nom,strlen(nom_fichier));
  strcpy(this->nom,nom_fichier);
  fclose(fichier);
}

void SaveOver(Maillage *this) {
  Save(this,this->nom);
}

void Visualize(Maillage *this,char* zoom_option,char* autre_option) {
  FILE *fichier;

  fichier=fopen("tmp1","w");  
  fprintf(fichier,"set data style line\n");
  //fprintf(fichier,"plot %s '%s' %s\n",zoom_option,this->nom,autre_option);
  fprintf(fichier,"plot %s 'tmp2' %s\n",zoom_option,autre_option);
  fprintf(fichier,"pause -1 \"Press Enter\"");
  fclose(fichier);
  Save(this,"tmp2");

  system("gnuplot tmp1");
  system("\\rm tmp1 tmp2");
}
