#ifndef MAILLAGE 
#define MAILLAGE

/*****************************************
*                                        *
*        TP CSI2 - ESSI3 1998/99         *
*                                        *
*    CAUVIN Florian - NAVARRO Mikael     *
*                                        *
* Definition d'une structure de Maillage *
*                                        *
*****************************************/

typedef struct {

  /* constantes dues au nombres de points */
  int jm,km;

  /* tableaux des valeurs modales */
  double **x;
  double **y;
  double **psi;

  /* nom du maillage */
  char* nom;

} Maillage;


/* initialisation */
void CreateMaillage(Maillage *this,char* nom_fichier);  /* a n'utiliser qu'une fois */

/* destruction */
void DestroyMaillage(Maillage *this);

/* Sauvegarde */
void Save(Maillage *this,char* nom_fichier);    /* ds un fichier donne      */
void SaveOver(Maillage *this);                  /* dans le meme fichier     */

/* visualisation du maillage grace a GNUPLOT */
void Visualize(Maillage *this,char* zoom_option,char* autre_option);


#endif
