#ifndef SOLV_ELLIP
#define SOLV_ELLIP

/*****************************************
*                                        *
*        TP CSI2 - ESSI3 1998/99         *
*                                        *
*    CAUVIN Florian - NAVARRO Mikael     *
*                                        *
* Construction d'un maillage elliptique  *
*                                        *
*****************************************/

#include "maillage.h"

typedef struct{
  /* les coefficients */
  double** alpha;
  double** beta;
  double** gamma;

  /* le maillage */
  Maillage *maillage;
} SolvEllip;


/* initialisation */
void CreateSolvEllip(SolvEllip *this,Maillage *maillage);

/* destruction */
void DestroySolvEllip(SolvEllip *this);

/* calcul d'une iteration */
void Iteration(SolvEllip *this);

extern void IterGaussSeidel(SolvEllip *this,double** u);
extern double Residu(SolvEllip *this,double** u);

extern void CalculCoefA(SolvEllip *this);
extern void CalculCoefD(SolvEllip *this);
extern void CalculCoefC(SolvEllip *this);
extern void CalculCoefB(SolvEllip *this);

extern void ResGlissementA(SolvEllip *this, double **u);
extern void ResNeumannD(SolvEllip *this, double **u);
extern void ResNeumannC(SolvEllip *this, double **u);
extern void ResNeumannB(SolvEllip *this, double **u);

#endif
